/*
**  First Person Sniper
** By PikaJade
** Based on Fang Popgun Modifications / Aerial Popgun by Clairebun
*/

//Add cvars
local corkradius = CV_RegisterVar({name = "fangcorkradius", defaultvalue = 8, flags = CV_NETVAR|CV_CHEAT, PossibleValue = {MIN = 1, MAX = 15}})
local corkspeed = CV_RegisterVar({name = "fangcorkspeed", defaultvalue = 100, flags = CV_NETVAR|CV_CHEAT, PossibleValue = CV_NATURAL})
local clipsize = CV_RegisterVar({name = "fangclipsize", defaultvalue = 2, flags = CV_NETVAR|CV_CHEAT, PossibleValue = CV_NATURAL})
local refiretime = CV_RegisterVar({name = "fangrefiretime", defaultvalue = 15, flags = CV_NETVAR|CV_CHEAT, PossibleValue = CV_NATURAL})


//Define air shooting sprites
freeslot("SPR2_FAIR","S_PLAY_AIRFIRE1","S_PLAY_AIRFIRE2","sfx_rldend","sfx_nmehit","sfx_msfire","sfx_reload")
states[S_PLAY_AIRFIRE1] = {
        sprite = SPR_PLAY,
        frame = SPR2_FAIR,
        tics = -1,
}
states[S_PLAY_AIRFIRE2] = {
        sprite = SPR_PLAY,
        frame = SPR2_FAIR,
        tics = -1,
}
local airstate1 = S_PLAY_AIRFIRE1
local airstate2 = S_PLAY_AIRFIRE2
local reloadsound = sfx_reload
local reloadfinishsound = sfx_rldend
local misfiresound =  sfx_msfire
local hitenemysound = sfx_nmehit
local gunslinging = false
local IsFang = function(player)
	return player.mo and player.mo.skin == "fang"
end

local function zpos(posmo, item)
	return (posmo.z + (posmo.height - mobjinfo[item].height)/2)
end

local function newGunslinger(player)
	gunslinging = true
	local mo = player.mo
	local onground = P_IsObjectOnGround(mo)
	local canstand = true
	
	if player.ammo == nil
		player.ammo = 2
	end
	
	//State: ready to gunsling
	if not ((player.pflags & (PF_SLIDING)) or (player.exiting) or (P_PlayerInPain(player)))
	and not (player.weapondelay)
	and not (player.panim == PA_ABILITY2)
		//Trigger firing action
		if (player.cmd.buttons & BT_USE)
			local bullet = nil

			mo.state = S_PLAY_FIRE
			player.panim = PA_ABILITY2
			player.weapondelay = refiretime.value
			if player.ammo <= 0
				S_StartSound(player.mo,misfiresound)
			else 
				bullet = P_SpawnPointMissile(
					mo,
					mo.x + P_ReturnThrustX(nil, mo.angle, FRACUNIT),
					mo.y + P_ReturnThrustY(nil, mo.angle, FRACUNIT),
					player.viewz + (sin(player.aiming)*90),
					player.revitem,
					mo.x, mo.y, player.viewz
				)
			end
			if bullet
			and bullet.valid
				player.ammo = $-1
				P_InstaThrust(bullet,bullet.angle,corkspeed.value*cos(player.aiming))
				bullet.momz = corkspeed.value*sin(player.aiming)
				bullet.radius = corkradius.value
			end
			player.drawangle = mo.angle
			//Air function
			if not(P_IsObjectOnGround(mo))
				P_SetMobjStateNF(mo,airstate1)
				player.mo.sprite2 = SPR2_FAIR
				player.airgun = true
			end
		end
	end
	
	//Running and jumping
	if player.panim == PA_ABILITY2 and P_IsObjectOnGround(mo) and player.cmd.buttons&BT_JUMP and not(player.popgunhistory&BT_JUMP)
		mo.state = S_PLAY_WALK
	end
	
	//Air gunning
	if not(P_IsObjectOnGround(mo)) and player.airgun == true and player.weapondelay
		if player.weapondelay < refiretime.value-1 and player.weapondelay > refiretime.value-3
			P_SetMobjStateNF(mo,airstate2)
		elseif player.weapondelay < refiretime.value-4
			P_SetMobjStateNF(mo,airstate1)
		end
		player.pflags = $|PF_JUMPDOWN
	end	
	if P_IsObjectOnGround(mo) and player.airgun == true
	or not player.weapondelay
		player.airgun = false
		if (player.weapondelay) then
			mo.state = S_PLAY_FIRE_FINISH
		end
	end
	
	if player.panim != PA_ABILITY2
		player.laststate = player.panim
		if player.ammo < clipsize.value
		and not(player.weapondelay)
		and player.panim != PA_PAIN
		and player.panim != PA_ABILITY2
			player.reloadticks = $+1
			if player.reloadticks == 5
				S_StartSound(player.mo,reloadsound)
			elseif player.reloadticks > 5
				player.reloadbob = min($+3,27)
				if player.reloadticks >= 30
					S_StartSound(player.mo,reloadfinishsound)
					player.ammo = clipsize.value
					player.reloadticks = 0
				end
			end
		else
			if player.panim != PA_PAIN
			and player.panim != PA_ABILITY
				player.reloadbob = max($-3,0)
			else
				player.reloadbob = 0
			end
			player.reloadticks = 0
			S_StopSoundByID(player.mo,reloadsound)
		end
	else
		player.reloadticks = 0
		player.reloadbob = 0
		S_StopSoundByID(player.mo,reloadsound)
		if player.weapondelay <= 0
			player.state = S_PLAY_WALK
			player.panim = player.laststate
		end
	end
end


////
//Hooks

//Input control before movement is handled
addHook("PreThinkFrame",do
	for player in players.iterate
		if not(IsFang(player))
		or G_RingSlingerGametype()
			return end
			
		if player.cmd.buttons & BT_ATTACK
			player.cmd.buttons = $|BT_SPIN
		end
	end
end)

//Main body for popgun firing control	
addHook("PlayerThink",function(player)
	if not(IsFang(player)) return end
	//Disallow native CA2_GUNSLINGER functionality
	if player.charability2 == CA2_GUNSLINGER
		player.charability2 = CA2_NONE 
	end
	
	//Define reload bob
	if not player.reloadbob
		player.reloadbob = 0
	end
	
	//Do not carry over ammo count between levels
	if player.realtime == 0
		player.ammo = 2
	end

	//Unable to use gun during certain states
	if player.powers[pw_nocontrol]
	or player.powers[pw_carry]
	or player.pflags&PF_SPINNING
	or (player.playerstate != PST_LIVE and player.jointime != 0)
	or player.exiting 
	or P_PlayerInPain(player)
		player.airgun = false
	return end

	if player.popgunhistory == nil
		player.popgunhistory = player.cmd.buttons
	end
	//Do Gunslinger
	newGunslinger(player)
	//Make SPR2 behave
	if (player.mo.state == S_PLAY_AIRFIRE1) then
	player.mo.frame = 0
	end
	if (player.mo.state == S_PLAY_AIRFIRE2) then
	player.mo.frame = 1
	end
	
	local fp = (player.playerstate == PST_REBORN)
	//Force first person
	if secondarydisplayplayer == player
		camera2.chase = fp
	else
		camera.chase = fp
	end
	
end)

//Update button history
addHook("PostThinkFrame",do
	for player in players.iterate
		player.popgunhistory = player.cmd.buttons	
	end
end)

//Shield ability regulation
addHook("ShieldSpecial",function(player)
	if IsFang(player)
		return true
	end
end)

//HUD
hud.add(function(v, p, cam)
	if not(IsFang(p))
	or cam.chase
		return end
	if not(gunslinging)
		--true
	elseif p.weapondelay  > refiretime.value/2
		v.draw(160,118,v.cachePatch("HUDGUNFIRE"),V_PERPLAYER,v.getColormap(p.mo.skin,p.mo.color))
	else
		v.draw(160,136+p.reloadbob,v.cachePatch("HUDGUNIDLE"),V_PERPLAYER,v.getColormap(p.mo.skin,p.mo.color))
	end
	
	if not paused
		gunslinging = false
	end
	
	if p.ammo == 0
	and p.jointime%10 >= 5
		v.draw(-16,50,v.cachePatch"STTRAMMO",V_HUDTRANS|V_PERPLAYER)
	else
		v.draw(-16,50,v.cachePatch"STTAMMO",V_HUDTRANS|V_PERPLAYER)
	end
	v.drawNum(88,50,p.ammo,V_HUDTRANS|V_PERPLAYER)
	
end, game)

//Give reward when hitting an enemy
addHook("ShouldDamage",function(t,i,mo,d,dt)
	if mo
	and i
	and t
	and mo.player
	and mo.skin == "fang"
	and t.state != t.info.painstate
	and i.type == MT_CORK
		mo.player.reloadticks = 0
		mo.player.ammo = clipsize.value
		S_StartSound(mo,hitenemysound)
		S_StartSound(mo,reloadfinishsound)
		if t.health - d <= 0
		and t.flags & MF_ENEMY
		and ~t.flags & MF_BOSS
			mo.player.rings = $+1
			S_StartSound(mo,sfx_itemup)
		end
	end
	return
end)